#
# spec file for package bitscope-dso (Version 1.2.1.06032103)
#
# Copyright (c) 2006 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# neededforbuild  w3m

BuildRequires:  aaa_base acl attr bash bind-utils bison bzip2 coreutils cpio cpp cracklib cvs cyrus-sasl db devs diffutils e2fsprogs file filesystem fillup findutils flex gawk gdbm-devel gettext-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv klogd less libacl libattr libcom_err libgcc libnscd libselinux libstdc++ libxcrypt libzio m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-modules patch permissions popt procinfo procps psmisc pwdutils rcs readline sed strace sysvinit tar tcpd texinfo timezone unzip util-linux vim zlib zlib-devel autoconf automake binutils gcc gdbm gettext libtool perl rpm w3m

Name:           bitscope-dso
Requires:       perl
License:        Contact author
Group:          Productivity/Scientific/Electronics
Autoreqprov:    on
Version:        1.2.1.06032103
Release:        6
Summary:        digital oscilloscope for bitscope.com devices
Url:            http://www.bitscope.com
Source:         http://www.bitscope.com/download/files/Dso-%{version}.tar.gz
Source1:        http://prdownloads.sourceforge.net/kylixlibs/kylixlibs3-borqt-3.0-2.tar.gz
Source2:        dso_home_wrapper.c
Source3:        license.html
Source4:        release-notes-1.2.1.html
Source5:        bitscope.pdf
Source6:        bs-pm-01.pdf
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
ExclusiveArch: %ix86

%description
DSO is a high performance multi-channel mixed signal digital storage
oscilloscope, logic analyzer,  spectrum analyzer, waveform generator
and  data acquisition application  for use  with any  model BitScope
including the original BS110 (after a simple hardware upgrade).

DSO is dual timebase with sophisticated triggers and includes a user
programmable post-trigger  delay. It is capaable  of capturing mixed
signal (ie,  analog and  logic), supports simultaneous	waveform and
spectrum display  and includes time and voltage  cursors for precise
signal measurement. The waveform  generator can be used for transfer
function analysis and/or where	a general purpose arbitrary waveform
generator might otherwise be  used. All features are independent but
integrated as "virtual instruments"  within the DSO software subject to
the capabilities of the BitScope model to which DSO is connected.

DSO can be used for both deep buffer one-shot capture and high speed
live refresh  analog or logic  display. Its operation is  similar to
traditional scopes so  it should be easy to  use for anyone familiar
with such test equipment.   The spectrum analyzer is fully automatic
and the  waveform generator  operates concurrently with  full sample
synchronous data capture (except on model BS50U).

DSO auto-configures for use with with all BitScope models from BS120
up. It can communicate with the host PC via RS-232, 10BaseT Ethernet
and USB  (depending the interface  used by your  BitScope). Built-in
networking allows live Internet  connections between the DSO and one or
more Network BitScopes.



Authors:
--------
    BitScope Designs <dso@bitscope.com>
    MetaChip Pty. Limited Trading

%prep
%setup -n dso -a1
cp %{S:2} .
cp %{S:3} .
cp %{S:4} .
cp %{S:5} .
cp %{S:6} .
# %patch

%build
# not much to build - we are repackaging binaries
# Just a preload wrapper, and some docu...
gcc $RPM_OPT_FLAGS -fPIC -shared -o dso_home_wrapper.so dso_home_wrapper.c -ldl
for i in *.html; do
  w3m -dump $i > ${i/\.html/\.txt}
done

%install
# libbor-qt is not searched via ldconfig.
# On my x86-64 it is searched in 
#
#/lib/tls/i686 /lib/tls /lib/i686 /lib
#/usr/lib/tls/i686/ /usr/lib/tls/ /usr/lib/i686/ /usr/lib/
#
# So it is pointless to use %{_libdir}, just hardcode ../lib/
%define	BIN_D		/usr/bin
%define	LIB_D		/usr/lib/bitscope-dso
%define	SHARE_D		/usr/share/bitscope-dso
%define	DOC_D		/usr/share/doc/packages/bitscope-dso
BINDIR=$RPM_BUILD_ROOT/%{BIN_D}
LIBDIR=$RPM_BUILD_ROOT/%{LIB_D}
SHAREDIR=$RPM_BUILD_ROOT/%{SHARE_D}
DOCDIR=$RPM_BUILD_ROOT/%{DOC_D}
mkdir -p $BINDIR
mkdir -p $LIBDIR
mkdir -p $SHAREDIR
mkdir -p $DOCDIR
install -m 755 dso_home_wrapper.so $LIBDIR
install -m 755 kylixlibs3-borqt/libborqt-6.9.0-qt2.3.so $LIBDIR/libborqt-6.9.0-qt2.3.so
(cd $LIBDIR;       ln -s libborqt-6.9.0-qt2.3.so libborqt-6.9-qt2.3.so)
(cd $RPM_BUILD_ROOT/usr/lib; ln -s %{LIB_D}/libborqt-6.9.0-qt2.3.so .; ln -s libborqt-6.9.0-qt2.3.so libborqt-6.9-qt2.3.so)
install -m 644 *.{html,txt,pdf} $DOCDIR
install -m 644 *.prb $SHAREDIR
install -m 755 Dso $LIBDIR
## in case the LD_PRELOAD trick fails, 
## let us see at least a readonly copy of the default probes file.
(cd $LIBDIR; ln -s %{SHARE_D}/BitScope.prb . )
(cd $BINDIR; cat > bitscope-dso << EOF)
#! /bin/sh
#
# bitscope-dso -- a startup script to get the mess clean.
#
# (C) 2006, jw@suse.de, 
# This script is under GPL V2
#
# This software expects the settings file in the same directory as the binary is.
# And it needs it writable. What a hack!
#
# We make a per-user copy in his home, and patch the open syscall, 
# so that BitScope.prb is always taken from his home.
#
# 
defsettings_dir=%{SHARE_D}
settings=BitScope.prb
dso_dir=\$HOME/.bitscope
test -d \$dso_dir || mkdir \$dso_dir
test -f "\$dso_dir/\$settings" || cp "\$defsettings_dir/\$settings" "\$dso_dir"
probe_dev=\$1
test -z "\$probe_dev" && probe_dev=\$(grep '^USB:' "\$dso_dir/\$settings"  |tr -d \\\\r | head -1)
case "\$probe_dev" in
   *USB*)
    a=\$(dmesg | grep 'FTDI FT232BM Compatible converter now' | tail -1 | sed -e 's@.*: @@')
    echo \$a
    case "\$a" in
      *disconnected*)
      echo " USB link failure. Try to reconnect USB cable."
      echo " (If this fails, try: rmmod ftdi_sio usbserial; then reconnect ...)"
      exit
      ;;
    esac
    ;;
esac
probe_dev=\$1
test -z "\$probe_dev" && probe_dev=\$(grep '^USB:' "\$dso_dir/\$settings"  |tr -d \\\\r | head -1)
probe_dev=\$(echo "\$probe_dev" | sed -e 's@^USB:@@')
if [ -e "\$probe_dev" ]; then
  echo "seen \$probe_dev"
else
  echo "error: \$probe_dev does not exist."
  echo "attach device, change \$dso_dir/\$settings, or give devicename as parameter."
  exit
fi
# preload does not work with group-sbit.
# env LD_PRELOAD=%{LIB_D}/dso_home_wrapper.so %{LIB_D}/Dso $@
# found a different way to cheat:
perl -e "exec {'%{LIB_D}/Dso'} '\$dso_dir/Dso'"
EOF
chmod 755 $BINDIR/bitscope-dso

%clean
rm -rf $RPM_BUILD_ROOT

%post
chgrp uucp %{LIB_D}/Dso
chmod 2755 %{LIB_D}/Dso
%run_ldconfig

%postun
%run_ldconfig

%files
%defattr(-,root,root)
%doc /usr/share/doc/packages/bitscope-dso
%dir /usr/share/bitscope-dso
/usr/share/bitscope-dso/*.prb
/usr/bin/*
%dir /usr/lib/bitscope-dso
/usr/lib/bitscope-dso/*
/usr/lib/libborqt-*

%changelog -n bitscope-dso
* Mon Oct 02 2006 - jw@suse.de
- replaced the the LD_PRELOAD hack, by a much simpler
  perl wrapper script.
* Sat Sep 30 2006 - aj@suse.de
- Fix filelist.
* Fri Sep 29 2006 - jw@suse.de
- preload wrapper catches lock file. No more setguid.
* Thu Sep 28 2006 - jw@suse.de
- startup script sanity checks.
* Mon Sep 25 2006 - jw@suse.de
- adjusting preload wrapper, so that WaveDate
  is written to $HOME/.bitscope, rather than /usr/lib/bitscope-dso,
* Fri Sep 22 2006 - jw@suse.de
- BitScope.prb is not found without a preload wrapper.
- moving from/opt/bitscope to /usr/{lib,share}/bitscope-dso
* Tue Sep 19 2006 - jw@suse.de
- initial version, 1.2.1
  Repackaging the binary package. No source available, sorry.
